/***************************************************************************
 *   Copyright (C) 2005 by Tavarez Arnaud Bakoula                          *
 *   tbakoula@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MARKSRC_H
#define MARKSRC_H

#include <qlabel.h>   // for inheritance
#include <qevent.h>

/**
@author Tavarez Arnaud Bakoula
*/
class MarkSrc : public QLabel
{

public:
    MarkSrc( uint i, QWidget* parent = 0, const char* name = 0 );
    ~MarkSrc();

    void setState( uint state )
    {  m_state = state;  }

    void updateMe();

protected:
    virtual void mouseMoveEvent( QMouseEvent* event );
    virtual void mousePressEvent  ( QMouseEvent* event );
    virtual void mouseReleaseEvent( QMouseEvent* event );

private:
    bool moving;   /*!< The cursor state */
    uint m_state;  /*!< The state of the mark */
};

#endif // MARKSRC_H
