/***************************************************************************
 *   Copyright (C) 2005 by Tavarez Arnaud Bakoula                          *
 *   tbakoula@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SITE_H
#define SITE_H

#include "cell.h"

/**
   @author: T.A. Bakoula
 */
class Site : public Cell
{
public:
    Site( uint r, uint c, int clr=-1 )
      : Cell( r, c ), color(clr) {}
    virtual ~Site() {}

    virtual void draw( QPainter*, QPoint pt=QPoint(0,0) );

    void setColor( int c ) { color = c; }
    int  getColor() const { return color; }

protected:
    int color;
};

#endif // SITE_H
